using System;
using System.Threading;

// Monitor med brug af Monitor Enter og Exit istedet for lock

namespace Trdeksempel_Parkeringshus_wait_notify
{
    class P_Hus_Monitor_Med_Monitor_Enter_Exit
    {
        private int antalBiler; // biler i huset
        private int pladser;	// antal parkeringspladser
        private object phus_ls = new object();     // privat lseobjekt

        public P_Hus_Monitor_Med_Monitor_Enter_Exit (int pladser)
        {
            this.pladser = pladser;
            antalBiler = 0;
        }

        public void bilKrerInd()
        {
            System.Console.WriteLine("Start p bilKrerInd");

            Monitor.Enter(phus_ls);
            
            System.Console.WriteLine("Start p bilKrerInd - Enter kritisk omrde");
            
            while (antalBiler == pladser)
            {
                System.Console.WriteLine("Parkeringshus fuldt - ingen indkrsler nu");
                Monitor.Wait(phus_ls);
            }

            if (antalBiler == 0)
            {
                System.Console.WriteLine("ben for udkrsler igen - 1. bil lige krer ind");
                Monitor.PulseAll(phus_ls);
            }

            antalBiler++;
            System.Console.WriteLine("Bil kret ind - der er nu ialt:" + antalBiler + " biler");

            Monitor.Exit(phus_ls);
        }

        public void bilKrerUd()
        {
            System.Console.WriteLine("Start p bilKrerUd");
            
            Monitor.Enter(phus_ls);
            
            System.Console.WriteLine("Start p bilKrerUd - Enter kritisk omrde");
            
            while (antalBiler == 0)
            {
                System.Console.WriteLine("Parkeringshus tomt - ingen udkrsler nu");
                Monitor.Wait(phus_ls);
            }

            if (antalBiler == pladser)
            {
                System.Console.WriteLine("ben for indkrsler igen - sidste plads bliver ledig");
                Monitor.PulseAll(phus_ls);
            }

            antalBiler--;
            System.Console.WriteLine("Bil krer ud - der er nu ialt:" + antalBiler + " biler");

            Monitor.Exit(phus_ls);
        }
    }
}
